"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MissingProvidedServiceTypeError = void 0;
const token_class_1 = require("../token.class");
/**
 * Thrown when service is registered without type.
 */
class MissingProvidedServiceTypeError extends Error {
    constructor(identifier) {
        var _a, _b;
        super();
        this.name = 'MissingProvidedServiceTypeError';
        /** Normalized identifier name used in the error message. */
        this.normalizedIdentifier = '<UNKNOWN_IDENTIFIER>';
        if (typeof identifier === 'string') {
            this.normalizedIdentifier = identifier;
        }
        else if (identifier instanceof token_class_1.Token) {
            this.normalizedIdentifier = `Token<${identifier.name || 'UNSET_NAME'}>`;
        }
        else if (identifier && (identifier.name || ((_a = identifier.prototype) === null || _a === void 0 ? void 0 : _a.name))) {
            this.normalizedIdentifier =
                `MaybeConstructable<${identifier.name}>` ||
                    `MaybeConstructable<${(_b = identifier.prototype) === null || _b === void 0 ? void 0 : _b.name}>`;
        }
    }
    get message() {
        return `Cannot determine a class of the requesting service: "${this.normalizedIdentifier}".`;
    }
}
exports.MissingProvidedServiceTypeError = MissingProvidedServiceTypeError;
//# sourceMappingURL=missing-provided-service-type.error.js.map